#include <bootstrap.h>
#include <kcms/kcms.h>
#include <kcms/private.h>

main(
   int   argc,
   char *argv[],
   char *envp[])
{
   kdatum   key;
   kdatum   data;
   klist   *list;
   kobject  toolbox;
   kdbm    *db;
   char     path[KLENGTH];
   char   **toolboxes;
   int      tb_num;
   int	    i;


   toolboxes = kcms_query_toolboxes(&tb_num);

   for (i = 0; i < tb_num; i++)
   {
      ksprintf(path,"$%s/repos/db/cms",toolboxes[i]);
      if ((db = kdbm_open(path,O_RDONLY, 0666)) == NULL)
      {
         kinfo(KSTANDARD, "Warning: Cannot open toolbox object '%s'\n",
                   toolboxes[i]);
         continue;
      }
/*
      for (key = kdbm_firstkey(db); key.dptr != NULL; key = kdbm_nextkey(db))
      {
         data = kdbm_fetch(db, key);
         kfprintf(kstdout,"%s:%s\n", key.dptr, data.dptr);
      }
*/

   kdb_get_key(db, KCMS_KEY_AUTHOR_EMAIL);
   kdb_get_key(db, "SOFTWARE_OBJECTS");
   kdb_get_key(db, KCMS_KEY_AUTHOR);
   kdb_get_key(db, KCMS_KEY_TITLE);
   kdb_get_key(db, KCMS_KEY_VERSION);
   kdb_get_key(db, KCMS_KEY_SHORT_COPYRIGHT);
   kdb_get_key(db, KCMS_KEY_LONG_COPYRIGHT);
   kdb_get_key(db, "SOFTWARE_OBJECTS");
   kdb_get_key(db, KCMS_KEY_INFO_FILE);
   kdb_get_key(db, KCMS_KEY_CONFIG_FILE);
   kdb_get_key(db, KCMS_KEY_ALIAS_FILE);
   kdb_get_key(db, KCMS_KEY_TODO);
   kdb_get_key(db, KCMS_KEY_CHANGELOG_FILE);
   kdb_get_key(db, KCMS_KEY_INCLUDE_FILE);

/*      kcms_get_attribute(toolbox, KCMS_TB_SOFTWARE_OBJECTS, &list);*/
/*      kcms_close(toolbox);*/
      kdbm_close(db);
   }

   kexit(KEXIT_SUCCESS);
}

kdb_get_key(kdbm *database, char *keyname)
{

   kdatum  key;
   kdatum  data;
   char   *info;

   key.dptr = keyname; 
   key.dsize = kstrlen(key.dptr) + 1;
   data = kdbm_fetch(database, key);
   info = kstring_cleanup(data.dptr, NULL);
   kfprintf(kstdout,"%s:%s\n", key.dptr, ((info == NULL)? " " : info));
}
